summaryrefslogtreecommitdiffstats
path: root/python/python3-maturin
diff options
context:
space:
mode:
Diffstat (limited to 'python/python3-maturin')
-rw-r--r--python/python3-maturin/README9
-rw-r--r--python/python3-maturin/mkvendored.sh17
-rw-r--r--python/python3-maturin/python3-maturin.SlackBuild117
-rw-r--r--python/python3-maturin/python3-maturin.info12
-rw-r--r--python/python3-maturin/slack-desc19
5 files changed, 174 insertions, 0 deletions
diff --git a/python/python3-maturin/README b/python/python3-maturin/README
new file mode 100644
index 0000000000..6271ee163d
--- /dev/null
+++ b/python/python3-maturin/README
@@ -0,0 +1,9 @@
+python3-maturin (Build and publish crates as python packages)
+
+Build and publish crates with pyo3, rust-cpython, cffi and uniffi
+bindings as well as rust binaries as python packages.
+
+This project is meant as a zero configuration replacement for
+setuptools-rust and milksnake. It supports building wheels for python
+3.5+ on windows, linux, mac and freebsd, can upload them to pypi and
+has basic pypy support.
diff --git a/python/python3-maturin/mkvendored.sh b/python/python3-maturin/mkvendored.sh
new file mode 100644
index 0000000000..c52093378e
--- /dev/null
+++ b/python/python3-maturin/mkvendored.sh
@@ -0,0 +1,17 @@
+#!/bin/bash
+
+# This is a wrapper script for cargo-mkvendored.sh which is
+# included in the cargo-vendor-filterer slackbuild and needs to be
+# installed. It is only needed if you are upgrading the version and
+# need new vendored rust libs.
+#
+# create $PRGNAM-vendored-sources-$VERSION-$VSBUILD.tar.xz
+# requires network access, but does not require root privilege.
+# requires that $PRGNAM's REQUIRES need to be installed first
+
+if [ -f /usr/bin/cargo-mkvendored.sh ]; then
+ /usr/bin/cargo-mkvendored.sh
+else
+ echo " ERROR: cargo-mkvendored.sh script is not available!!
+ ERROR: Install the cargo-vendor-filterer slackbuild."
+fi
diff --git a/python/python3-maturin/python3-maturin.SlackBuild b/python/python3-maturin/python3-maturin.SlackBuild
new file mode 100644
index 0000000000..42431d25d0
--- /dev/null
+++ b/python/python3-maturin/python3-maturin.SlackBuild
@@ -0,0 +1,117 @@
+#!/bin/bash
+
+# Slackware build script for python3-maturin
+
+# Copyright 2023-2024 fourtysixandtwo <fourtysixandtwo@sliderr.net>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# 20231008 46and2: Set ARCH=i686 as minimum.
+# 20240102 46and2: Use VSBUILD for vendored sources
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=python3-maturin
+SRCNAM=${PRGNAM#python3-*}
+VERSION=${VERSION:-1.5.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+VSBUILD=${VSBUILD:-1}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i686 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.?z
+tar xvf $CWD/$SRCNAM-vendored-sources-$VERSION-$VSBUILD.tar.?z
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \+
+
+# prevent cargo from using the network.
+# this only works because we have a vendored sources tarball with
+# everything cargo would have downloaded.
+export CARGO_NET_OFFLINE=true
+
+# prevent cargo from writing outside of $TMP
+export CARGO_HOME=$(pwd)/.cargo
+
+export PATH="/opt/rust16/bin:$PATH"
+if [ -z "$LD_LIBRARY_PATH" ]; then
+ export LD_LIBRARY_PATH="/opt/rust16/lib$LIBDIRSUFFIX"
+else
+ export LD_LIBRARY_PATH="/opt/rust16/lib$LIBDIRSUFFIX:$LD_LIBRARY_PATH"
+fi
+
+PYVER=$(python3 -c 'import sys; print("%d.%d" % sys.version_info[:2])')
+export PYTHONPATH=/opt/python$PYVER/site-packages
+
+python3 -m build --no-isolation
+python3 -m installer -d "$PKG" dist/*.whl
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a Changelog.md license-* PKG-INFO README.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/python/python3-maturin/python3-maturin.info b/python/python3-maturin/python3-maturin.info
new file mode 100644
index 0000000000..92c71c2f79
--- /dev/null
+++ b/python/python3-maturin/python3-maturin.info
@@ -0,0 +1,12 @@
+PRGNAM="python3-maturin"
+VERSION="1.5.1"
+HOMEPAGE="https://github.com/PyO3/maturin"
+DOWNLOAD="https://files.pythonhosted.org/packages/source/m/maturin/maturin-1.5.1.tar.gz \
+ https://slackware.uk/~fourtysixandtwo/src/maturin-vendored-sources-1.5.1-1.tar.xz"
+MD5SUM="f2d2e72a6d97a7561e7d7222090418af \
+ de11e6557b831f50d7c3df7baaa88fae"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="rust16 python3-setuptools-rust-opt"
+MAINTAINER="fourtysixandtwo"
+EMAIL="fourtysixandtwo@sliderr.net"
diff --git a/python/python3-maturin/slack-desc b/python/python3-maturin/slack-desc
new file mode 100644
index 0000000000..51ad3b31aa
--- /dev/null
+++ b/python/python3-maturin/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+python3-maturin: python3-maturin (Build and publish crates as python packages)
+python3-maturin:
+python3-maturin: Build and publish crates with pyo3, rust-cpython, cffi and uniffi
+python3-maturin: bindings as well as rust binaries as python packages.
+python3-maturin:
+python3-maturin: This project is meant as a zero configuration replacement for
+python3-maturin: setuptools-rust and milksnake. It supports building wheels for python
+python3-maturin: 3.5+ on windows, linux, mac and freebsd, can upload them to pypi and
+python3-maturin: has basic pypy support.
+python3-maturin:
+python3-maturin: Homepage: https://github.com/PyO3/maturin